Index: trunk/SophyaLib/NTools/fftpackc.c
===================================================================
--- trunk/SophyaLib/NTools/fftpackc.c	(revision 753)
+++ trunk/SophyaLib/NTools/fftpackc.c	(revision 756)
@@ -8400,20 +8400,20 @@
 
 /*  ------ File dfftf1.f ------ */
-/* Subroutine */ int dfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, 
+/* Subroutine */ int dfftf1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, 
 	int_8 *ifac)
 {
     /* System generated locals */
-    integer i__1;
+    int_4 i__1;
 
     /* Local variables */
-    extern /* Subroutine */ int dadf2_(integer *, integer *, r_8 *, r_8 *, 
-	    r_8 *), dadf3_(integer *, integer *, r_8 *, r_8 *, r_8 *, 
-	    r_8 *), dadf4_(integer *, integer *, r_8 *, r_8 *, r_8 *, 
-	    r_8 *, r_8 *), dadf5_(integer *, integer *, r_8 *, r_8 *, 
+    extern /* Subroutine */ int dadf2_(int_4 *, int_4 *, r_8 *, r_8 *, 
+	    r_8 *), dadf3_(int_4 *, int_4 *, r_8 *, r_8 *, r_8 *, 
+	    r_8 *), dadf4_(int_4 *, int_4 *, r_8 *, r_8 *, r_8 *, 
+	    r_8 *, r_8 *), dadf5_(int_4 *, int_4 *, r_8 *, r_8 *, 
 	    r_8 *, r_8 *, r_8 *, r_8 *);
-    static integer i__;
-    extern /* Subroutine */ int dadfg_(integer *, integer *, integer *, 
-	    integer *, r_8 *, r_8 *, r_8 *, r_8 *, r_8 *, r_8 *);
-    static integer k1, l1, l2, na, kh, nf, ip, iw, ix2, ix3, ix4, ido, idl1;
+    static int_4 i__;
+    extern /* Subroutine */ int dadfg_(int_4 *, int_4 *, int_4 *, 
+	    int_4 *, r_8 *, r_8 *, r_8 *, r_8 *, r_8 *, r_8 *);
+    static int_4 k1, l1, l2, na, kh, nf, ip, iw, ix2, ix3, ix4, ido, idl1;
 
     /* Parameter adjustments */
@@ -8523,7 +8523,7 @@
 
 /*  ------ File dffti.f ------ */
-/* Subroutine */ int dffti_(integer *n, r_8 *wsave)
-{
-    extern /* Subroutine */ int dffti1_(integer *, r_8 *, int_8 *);
+/* Subroutine */ int dffti_(int_4 *n, r_8 *wsave)
+{
+    extern /* Subroutine */ int dffti1_(int_4 *, r_8 *, int_8 *);
 
     /* Parameter adjustments */
@@ -8539,12 +8539,12 @@
 
 /*  ------ File dffti1.f ------ */
-/* Subroutine */ int dffti1_(integer *n, r_8 *wa, int_8 *ifac)
+/* Subroutine */ int dffti1_(int_4 *n, r_8 *wa, int_8 *ifac)
 {
     /* Initialized data */
 
-    static integer ntryh[4] = { 4,2,3,5 };
+    static int_4 ntryh[4] = { 4,2,3,5 };
 
     /* System generated locals */
-    integer i__1, i__2, i__3;
+    int_4 i__1, i__2, i__3;
 
     /* Builtin functions */
@@ -8553,13 +8553,13 @@
     /* Local variables */
     static r_8 argh;
-    static integer ntry, i__, j;
+    static int_4 ntry, i__, j;
     static r_8 argld;
-    static integer k1, l1, l2, ib;
+    static int_4 k1, l1, l2, ib;
     static r_8 fi;
-    static integer ld, ii, nf, ip, nl, is, nq, nr;
+    static int_4 ld, ii, nf, ip, nl, is, nq, nr;
     static r_8 arg;
-    static integer ido, ipm;
+    static int_4 ido, ipm;
     static r_8 tpi;
-    static integer nfm1;
+    static int_4 nfm1;
 
     /* Parameter adjustments */
@@ -8654,14 +8654,14 @@
 
 /*  ------ File dsinqb.f ------ */
-/* Subroutine */ int dsinqb_(integer *n, r_8 *x, r_8 *wsave)
+/* Subroutine */ int dsinqb_(int_4 *n, r_8 *x, r_8 *wsave)
 {
     /* System generated locals */
-    integer i__1;
+    int_4 i__1;
 
     /* Local variables */
-    static integer k;
-    extern /* Subroutine */ int dcosqb_(integer *, r_8 *, r_8 *);
+    static int_4 k;
+    extern /* Subroutine */ int dcosqb_(int_4 *, r_8 *, r_8 *);
     static r_8 xhold;
-    static integer kc, ns2;
+    static int_4 kc, ns2;
 
     /* Parameter adjustments */
@@ -8695,14 +8695,14 @@
 
 /*  ------ File dsinqf.f ------ */
-/* Subroutine */ int dsinqf_(integer *n, r_8 *x, r_8 *wsave)
+/* Subroutine */ int dsinqf_(int_4 *n, r_8 *x, r_8 *wsave)
 {
     /* System generated locals */
-    integer i__1;
+    int_4 i__1;
 
     /* Local variables */
-    static integer k;
-    extern /* Subroutine */ int dcosqf_(integer *, r_8 *, r_8 *);
+    static int_4 k;
+    extern /* Subroutine */ int dcosqf_(int_4 *, r_8 *, r_8 *);
     static r_8 xhold;
-    static integer kc, ns2;
+    static int_4 kc, ns2;
 
     /* Parameter adjustments */
@@ -8733,7 +8733,7 @@
 
 /*  ------ File dsinqi.f ------ */
-/* Subroutine */ int dsinqi_(integer *n, r_8 *wsave)
-{
-    extern /* Subroutine */ int dcosqi_(integer *, r_8 *);
+/* Subroutine */ int dsinqi_(int_4 *n, r_8 *wsave)
+{
+    extern /* Subroutine */ int dcosqi_(int_4 *, r_8 *);
 
     /* Parameter adjustments */
@@ -8746,9 +8746,9 @@
 
 /*  ------ File dsint.f ------ */
-/* Subroutine */ int dsint_(integer *n, r_8 *x, r_8 *wsave)
-{
-    extern /* Subroutine */ int dsint1_(integer *, r_8 *, r_8 *, r_8 *, 
+/* Subroutine */ int dsint_(int_4 *n, r_8 *x, r_8 *wsave)
+{
+    extern /* Subroutine */ int dsint1_(int_4 *, r_8 *, r_8 *, r_8 *, 
 	    r_8 *, int_8 *);
-    static integer np1, iw1, iw2, iw3;
+    static int_4 np1, iw1, iw2, iw3;
 
     /* Parameter adjustments */
@@ -8766,5 +8766,5 @@
 
 /*  ------ File dsint1.f ------ */
-/* Subroutine */ int dsint1_(integer *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *
+/* Subroutine */ int dsint1_(int_4 *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *
 	x, int_8 *ifac)
 {
@@ -8774,12 +8774,12 @@
 
     /* System generated locals */
-    integer i__1;
+    int_4 i__1;
 
     /* Local variables */
-    static integer modn, i__, k;
+    static int_4 modn, i__, k;
     static r_8 xhold, t1, t2;
-    extern /* Subroutine */ int dfftf1_(integer *, r_8 *, r_8 *, r_8 *, 
+    extern /* Subroutine */ int dfftf1_(int_4 *, r_8 *, r_8 *, r_8 *, 
 	    int_8 *);
-    static integer kc, np1, ns2;
+    static int_4 kc, np1, ns2;
 
     /* Parameter adjustments */
@@ -8852,5 +8852,5 @@
 
 /*  ------ File dsinti.f ------ */
-/* Subroutine */ int dsinti_(integer *n, r_8 *wsave)
+/* Subroutine */ int dsinti_(int_4 *n, r_8 *wsave)
 {
     /* Initialized data */
@@ -8859,5 +8859,5 @@
 
     /* System generated locals */
-    integer i__1;
+    int_4 i__1;
 
     /* Builtin functions */
@@ -8865,8 +8865,8 @@
 
     /* Local variables */
-    static integer k;
-    extern /* Subroutine */ int dffti_(integer *, r_8 *);
+    static int_4 k;
+    extern /* Subroutine */ int dffti_(int_4 *, r_8 *);
     static r_8 dt;
-    static integer np1, ns2;
+    static int_4 np1, ns2;
 
     /* Parameter adjustments */
Index: trunk/SophyaLib/NTools/fftpackc.h
===================================================================
--- trunk/SophyaLib/NTools/fftpackc.h	(revision 753)
+++ trunk/SophyaLib/NTools/fftpackc.h	(revision 756)
@@ -8,12 +8,12 @@
 #endif
 
-typedef int integer;
-typedef unsigned uinteger;
-typedef char *address;
-typedef short int shortint;
-  // typedef float real;
-  // typedef double doublereal;
-  //typedef struct { float r, i; } complex;
-  //typedef struct { double r, i; } doublecomplex;
+  /* typedef int integer;
+  typedef unsigned uinteger;
+  typedef char *address;
+  typedef short int shortint;
+  typedef float real;
+  typedef double doublereal;
+  typedef struct { float r, i; } complex;
+  typedef struct { double r, i; } doublecomplex;  */
 
 /* typedef int_4 logical;
@@ -24,105 +24,105 @@
 /* ---------------------- */
 
-extern int cfftb_(integer *n, r_4 *c__, r_4 *wsave);
-extern int cfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int cfftf_(integer *n, r_4 *c__, r_4 *wsave);
-extern int cfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int cffti_(integer *n, r_4 *wsave);
-extern int cffti1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int cosqb_(integer *n, r_4 *x, r_4 *wsave);
-extern int cosqb1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
-extern int cosqf_(integer *n, r_4 *x, r_4 *wsave);
-extern int cosqf1_(integer *n, r_4 *x, r_4 *w, r_4 *xh);
-extern int cosqi_(integer *n, r_4 *wsave);
-extern int cost_(integer *n, r_4 *x, r_4 *wsave);
-extern int costi_(integer *n, r_4 *wsave);
-extern int ezfft1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int ezfftb_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
-extern int ezfftf_(integer *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
-extern int ezffti_(integer *n, r_4 *wsave);
-extern int passb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int passb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int passb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int passb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int passb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int passf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int passf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int passf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int passf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int passf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radb2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int radb3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int radb4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int radb5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int radf2_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
-extern int radf3_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
-extern int radf4_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
-extern int radf5_(integer *ido, integer *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
-extern int radfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
-extern int rfftb_(integer *n, r_4 *r__, r_4 *wsave);
-extern int rfftb1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int rfftf_(integer *n, r_4 *r__, r_4 *wsave);
-extern int rfftf1_(integer *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
-extern int rffti_(integer *n, r_4 *wsave);
-extern int rffti1_(integer *n, r_4 *wa, int_4 *ifac);
-extern int sinqb_(integer *n, r_4 *x, r_4 *wsave);
-extern int sinqf_(integer *n, r_4 *x, r_4 *wsave);
-extern int sinqi_(integer *n, r_4 *wsave);
-extern int sint_(integer *n, r_4 *x, r_4 *wsave);
-extern int sint1_(integer *n, r_4 *war, r_4 *was, r_4 *xh, r_4 *x, int_4 *ifac);
-extern int sinti_(integer *n, r_4 *wsave);
+extern int cfftb_(int_4 *n, r_4 *c__, r_4 *wsave);
+extern int cfftb1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cfftf_(int_4 *n, r_4 *c__, r_4 *wsave);
+extern int cfftf1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int cffti_(int_4 *n, r_4 *wsave);
+extern int cffti1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int cosqb_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int cosqb1_(int_4 *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqf_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int cosqf1_(int_4 *n, r_4 *x, r_4 *w, r_4 *xh);
+extern int cosqi_(int_4 *n, r_4 *wsave);
+extern int cost_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int costi_(int_4 *n, r_4 *wsave);
+extern int ezfft1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int ezfftb_(int_4 *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezfftf_(int_4 *n, r_4 *r__, r_4 *azero, r_4 *a, r_4 *b, r_4 *wsave);
+extern int ezffti_(int_4 *n, r_4 *wsave);
+extern int passb_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passb2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passb3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passb4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passb5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int passf_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int passf2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int passf3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int passf4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int passf5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radb2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radb3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radb4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radb5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radbg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int radf2_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1);
+extern int radf3_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2);
+extern int radf4_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3);
+extern int radf5_(int_4 *ido, int_4 *l1, r_4 *cc, r_4 *ch, r_4 *wa1, r_4 *wa2, r_4 *wa3, r_4 *wa4);
+extern int radfg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_4 *cc, r_4 *c1, r_4 *c2, r_4 *ch, r_4 *ch2, r_4 *wa);
+extern int rfftb_(int_4 *n, r_4 *r__, r_4 *wsave);
+extern int rfftb1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rfftf_(int_4 *n, r_4 *r__, r_4 *wsave);
+extern int rfftf1_(int_4 *n, r_4 *c__, r_4 *ch, r_4 *wa, int_4 *ifac);
+extern int rffti_(int_4 *n, r_4 *wsave);
+extern int rffti1_(int_4 *n, r_4 *wa, int_4 *ifac);
+extern int sinqb_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sinqf_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sinqi_(int_4 *n, r_4 *wsave);
+extern int sint_(int_4 *n, r_4 *x, r_4 *wsave);
+extern int sint1_(int_4 *n, r_4 *war, r_4 *was, r_4 *xh, r_4 *x, int_4 *ifac);
+extern int sinti_(int_4 *n, r_4 *wsave);
 
 /* ---------------------- */
 
-extern int cdfftb_(integer *n, r_8 *c__, r_8 *wsave);
-extern int cdfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int cdfftf_(integer *n, r_8 *c__, r_8 *wsave);
-extern int cdfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int cdffti_(integer *n, r_8 *wsave);
-extern int cdffti1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dcosqb_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosqb1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
-extern int dcosqf_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosqf1_(integer *n, r_8 *x, r_8 *w, r_8 *xh);
-extern int dcosqi_(integer *n, r_8 *wsave);
-extern int dcost_(integer *n, r_8 *x, r_8 *wsave);
-extern int dcosti_(integer *n, r_8 *wsave);
-extern int dezfft1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dezfftb_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
-extern int dezfftf_(integer *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
-extern int dezffti_(integer *n, r_8 *wsave);
-extern int dpassb_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dpassb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dpassb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dpassb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dpassb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dpassf_(integer *nac, integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dpassf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dpassf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dpassf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dpassf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadb2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dadb3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dadb4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dadb5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadbg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dadf2_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
-extern int dadf3_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
-extern int dadf4_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
-extern int dadf5_(integer *ido, integer *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
-extern int dadfg_(integer *ido, integer *ip, integer *l1, integer *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
-extern int dfftb_(integer *n, r_8 *r__, r_8 *wsave);
-extern int dfftb1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int dfftf_(integer *n, r_8 *r__, r_8 *wsave);
-extern int dfftf1_(integer *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
-extern int dffti_(integer *n, r_8 *wsave);
-extern int dffti1_(integer *n, r_8 *wa, int_8 *ifac);
-extern int dsinqb_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsinqf_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsinqi_(integer *n, r_8 *wsave);
-extern int dsint_(integer *n, r_8 *x, r_8 *wsave);
-extern int dsint1_(integer *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *x, int_8 *ifac);
-extern int dsinti_(integer *n, r_8 *wsave);
+extern int cdfftb_(int_4 *n, r_8 *c__, r_8 *wsave);
+extern int cdfftb1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdfftf_(int_4 *n, r_8 *c__, r_8 *wsave);
+extern int cdfftf1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int cdffti_(int_4 *n, r_8 *wsave);
+extern int cdffti1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dcosqb_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosqb1_(int_4 *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqf_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosqf1_(int_4 *n, r_8 *x, r_8 *w, r_8 *xh);
+extern int dcosqi_(int_4 *n, r_8 *wsave);
+extern int dcost_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dcosti_(int_4 *n, r_8 *wsave);
+extern int dezfft1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dezfftb_(int_4 *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezfftf_(int_4 *n, r_8 *r__, r_8 *azero, r_8 *a, r_8 *b, r_8 *wsave);
+extern int dezffti_(int_4 *n, r_8 *wsave);
+extern int dpassb_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassb2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassb3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassb4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassb5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dpassf_(int_4 *nac, int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dpassf2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dpassf3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dpassf4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dpassf5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadb2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadb3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadb4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadb5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadbg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dadf2_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1);
+extern int dadf3_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2);
+extern int dadf4_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3);
+extern int dadf5_(int_4 *ido, int_4 *l1, r_8 *cc, r_8 *ch, r_8 *wa1, r_8 *wa2, r_8 *wa3, r_8 *wa4);
+extern int dadfg_(int_4 *ido, int_4 *ip, int_4 *l1, int_4 *idl1, r_8 *cc, r_8 *c1, r_8 *c2, r_8 *ch, r_8 *ch2, r_8 *wa);
+extern int dfftb_(int_4 *n, r_8 *r__, r_8 *wsave);
+extern int dfftb1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dfftf_(int_4 *n, r_8 *r__, r_8 *wsave);
+extern int dfftf1_(int_4 *n, r_8 *c__, r_8 *ch, r_8 *wa, int_8 *ifac);
+extern int dffti_(int_4 *n, r_8 *wsave);
+extern int dffti1_(int_4 *n, r_8 *wa, int_8 *ifac);
+extern int dsinqb_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsinqf_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsinqi_(int_4 *n, r_8 *wsave);
+extern int dsint_(int_4 *n, r_8 *x, r_8 *wsave);
+extern int dsint1_(int_4 *n, r_8 *war, r_8 *was, r_8 *xh, r_8 *x, int_8 *ifac);
+extern int dsinti_(int_4 *n, r_8 *wsave);
 
 /* Rerunning f2c -P may change prototypes or declarations. */
Index: trunk/SophyaLib/NTools/nbmath.h
===================================================================
--- trunk/SophyaLib/NTools/nbmath.h	(revision 753)
+++ trunk/SophyaLib/NTools/nbmath.h	(revision 756)
@@ -5,4 +5,5 @@
 
 #include "machdefs.h"
+#include "smathconst.h"
 
 #ifdef __cplusplus
@@ -10,43 +11,4 @@
 #endif
 
-/* EA conflit entre les diverses copies de nbmath.h, nbconst.h... A nettoyer... */
-#undef  Pi   
-#undef  Pis2
-#undef  DeuxPi 
-#undef  SPi   
-#undef  S2Pi   
-#undef  Rac2   
-#undef  Log2   
-#undef  LnPi   
-#undef  LgPi   
-#undef  Ln10   
-#undef  DftoDm 
-#undef  Hln2pi 
-#undef  JourSec 
-#undef  AnSec  
-
-#undef  GRAND  
-#undef  GRAND2 
-#undef  IGRAND 
-
-#define  Pi     (double) ( 3.14159265358979310e+00)  /* c'est Pi */
-#define  Pis2   (double) (1.57079632679489655)       /* c'est Pi/2 */
-#define  DeuxPi (double) ( 6.28318530717958620e+00)  /* c'est 2*Pi */
-#define  SPi    (double) ( 1.77245385090551590e+00)  /* c'est sqrt(Pi) */
-#define  S2Pi   (double) ( 2.50662827463100020e+00)  /* c'est sqrt(2*Pi) */
-#define  Rac2   (double) ( 1.41421356237309510e+00)  /* c'est sqrt(2) */
-#define  Log2   (double) ( 3.01029995663981200e-01)  /* c'est log10(2) */
-#define  LnPi   (double) ( 1.14472988584940020e+00)  /* c'est ln(Pi) */
-#define  LgPi   (double) ( 4.97149872694133850e-01)  /* c'est log10(Pi) */
-#define  Ln10   (double) ( 2.30258509299404590e+00)  /* c'est ln(10) */
-#define  DftoDm (double) ( 1.08573620475812940e+00)  /* c'est 2.5/ln(10) */
-#define  Hln2pi (double) ( 9.18938533204672670e-01)  /* c'est Ln(2*pi)/2 */
-
-#define  JourSec (float) (86400.000000) /* nombre de secondes dans 24H */
-#define  AnSec  (int) (31557600) /* nombre de secondes dans 365.25 jours */
-
-#define  GRAND  (float)  (1.e+35)
-#define  GRAND2 (double) (1.e+35)
-#define  IGRAND (int_4) (2147483647)
 
 /* pour le fit 1-dim */
Index: trunk/SophyaLib/NTools/objfitter.cc
===================================================================
--- trunk/SophyaLib/NTools/objfitter.cc	(revision 756)
+++ trunk/SophyaLib/NTools/objfitter.cc	(revision 756)
@@ -0,0 +1,189 @@
+#include "objfitter.h"
+
+TMatrix<r_4>
+ObjectFitter::FitResidus(TMatrix<r_4> const & mtx, GeneralFit& gfit,
+			 double xorg, double yorg, double dx, double dy)
+{
+  return( ArrayFitter<r_4>::FitResidus(mtx, gfit, xorg, yorg, dx, dy) );
+}
+
+TMatrix<r_8>
+ObjectFitter::FitResidus(TMatrix<r_8> const & mtx, GeneralFit& gfit,
+			 double xorg, double yorg, double dx, double dy)
+{
+  return( ArrayFitter<r_8>::FitResidus(mtx, gfit, xorg, yorg, dx, dy) );
+}
+
+TMatrix<r_4>
+ObjectFitter::FitFunction(TMatrix<r_4> const & mtx, GeneralFit& gfit,
+			 double xorg, double yorg, double dx, double dy)
+{
+  return( ArrayFitter<r_4>::FitFunction(mtx, gfit, xorg, yorg, dx, dy) );
+}
+
+TMatrix<r_8>
+ObjectFitter::FitFunction(TMatrix<r_8> const & mtx, GeneralFit& gfit,
+			 double xorg, double yorg, double dx, double dy)
+{
+  return( ArrayFitter<r_8>::FitFunction(mtx, gfit, xorg, yorg, dx, dy) );
+}
+
+TVector<r_4>
+ObjectFitter::FitResidus(TVector<r_4> const & vec, GeneralFit& gfit,
+			       double xorg, double dx)
+{  
+  return( ArrayFitter<r_4>::FitResidus(vec, gfit, xorg, dx) );
+}
+
+TVector<r_8>
+ObjectFitter::FitResidus(TVector<r_8> const & vec, GeneralFit& gfit,
+			       double xorg, double dx)
+{  
+  return( ArrayFitter<r_8>::FitResidus(vec, gfit, xorg, dx) );
+}
+
+TVector<r_4>
+ObjectFitter::FitFunction(TVector<r_4> const & vec, GeneralFit& gfit,
+			       double xorg, double dx)
+{  
+  return( ArrayFitter<r_4>::FitFunction(vec, gfit, xorg, dx) );
+}
+
+TVector<r_8>
+ObjectFitter::FitFunction(TVector<r_8> const & vec, GeneralFit& gfit,
+			       double xorg, double dx)
+{  
+  return( ArrayFitter<r_8>::FitFunction(vec, gfit, xorg, dx) );
+}
+
+
+// ---------------------------------------------------------------------------
+
+template <class T>
+TMatrix<T> 
+ArrayFitter<T>::FitResidus(TMatrix<T> const & mtx, GeneralFit& gfit,
+			 double xorg=0.,double yorg=0.,double dx=1.,double dy=1.)
+// Retourne une classe contenant les residus du fit ``gfit''.
+// On suppose que x=j (colonnes) et y=i (lignes) pour m(i,j).
+// Les coordonnees de l'element (i,j) sont :
+//    (i,j) -> x = xorg+j*dx , y = yorg+i*dy
+{
+if(mtx.NCols()<=0||mtx.NRows()<=0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TMatrix<T>...) size mismatch\n"));
+GeneralFunction* f = gfit.GetFunction();
+if(f==NULL)
+  throw(NullPtrError("ArrayFitter::FitResidus(TMatrix<T>...) GeneraFit==NULL\n"));
+int npar =  gfit.GetNPar();
+if(npar==0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TMatrix<T>...) GeneraFit 0 parametre\n"));
+double* par = new double[npar];
+{for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
+TMatrix<T> m(mtx);
+m.SetTemp(true);
+for(uint_4 i=0;i<mtx.NRows();i++) for(uint_4 j=0;j<mtx.NCols();j++) {
+  double x[2] = {xorg+j*dx,yorg+i*dy};
+  m(i,j) -= f->Value(x,par);
+}
+delete [] par;
+return m;
+}
+
+
+template <class T>
+TMatrix<T> 
+ArrayFitter<T>::FitFunction(TMatrix<T> const & mtx, GeneralFit& gfit,
+			  double xorg=0.,double yorg=0.,double dx=1.,double dy=1.)
+
+// Retourne une classe contenant la fonction du fit ``gfit''.
+// On suppose que x=j (colonnes) et y=i (lignes) pour m(i,j).
+// Les coordonnees de l'element (i,j) sont :
+//    (i,j) -> x = xorg + j*dx , y = yorg + i*dy
+
+{
+if(mtx.NCols()<=0||mtx.NRows()<=0)
+  throw(SzMismatchError("ArrayFitter::FitFunction(TMatrix<T>...) size mismatch\n"));
+GeneralFunction* f = gfit.GetFunction();
+if(f==NULL)
+  throw(NullPtrError("ArrayFitter::FitFunction(TMatrix<T>...) GeneraFit==NULL\n"));
+int npar =  gfit.GetNPar();
+if(npar==0)
+  throw(SzMismatchError("ArrayFitter::FitFunction(TMatrix<T>...) GeneraFit 0 parametre\n"));
+double* par = new double[npar];
+{for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
+TMatrix<T> m(mtx.NRows(), mtx.NCols());
+m.SetTemp(true);
+for(uint_4 i=0;i<mtx.NRows();i++) for(uint_4 j=0;j<mtx.NCols();j++) {
+  double x[2] = {xorg+j*dx,yorg+i*dy};
+  m(i,j) = f->Value(x,par);
+}
+delete [] par;
+return m;
+
+}
+
+template <class T>
+TVector<T> 
+ArrayFitter<T>::FitResidus(TVector<T> const & vec, GeneralFit& gfit,
+			 double xorg=0.,double dx=1.)
+// Retourne une classe contenant les residus du fit ``gfit''.
+// La coordonnee de l'element (i) est -> x = xorg + i*dx
+{
+if(vec.NElts()<=0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TVector<T>...)  size mismatch\n"));
+GeneralFunction* f = gfit.GetFunction();
+if(f==NULL)
+  throw(NullPtrError("ArrayFitter::FitResidus(TVector<T>...) GeneraFit==NULL\n"));
+int npar =  gfit.GetNPar();
+if(npar==0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TVector<T>...) GeneraFit 0 parametre\n"));
+double* par = new double[npar];
+{for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
+TVector<T> v(vec);
+v.SetTemp(true);
+for(uint_4 i=0;i<vec.NElts();i++) {
+  double x = xorg+i*dx;
+  v(i) -= f->Value(&x,par);
+}
+delete [] par;
+return v;
+}
+
+template <class T>
+TVector<T> 
+ArrayFitter<T>::FitFunction(TVector<T> const & vec, GeneralFit& gfit,
+			  double xorg=0.,double dx=1.)
+// Retourne une classe contenant les residus du fit ``gfit''.
+// La coordonnee de l'element (i) est -> x = xorg + i*dx
+{
+if(vec.NElts()<=0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TVector<T>...)  size mismatch\n"));
+GeneralFunction* f = gfit.GetFunction();
+if(f==NULL)
+  throw(NullPtrError("ArrayFitter::FitResidus(TVector<T>...) GeneraFit==NULL\n"));
+int npar =  gfit.GetNPar();
+if(npar==0)
+  throw(SzMismatchError("ArrayFitter::FitResidus(TVector<T>...) GeneraFit 0 parametre\n"));
+double* par = new double[npar];
+{for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
+TVector<T> v(vec.NElts());
+v.SetTemp(true);
+for(uint_4 i=0;i<vec.NElts();i++) {
+  double x = xorg+i*dx;
+  v(i) = f->Value(&x,par);
+}
+delete [] par;
+return v;
+}
+
+
+///////////////////////////////////////////////////////////////
+#ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template ArrayFitter<r_4>
+#pragma define_template ArrayFitter<r_8>
+#endif
+
+#if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+template class ArrayFitter<r_4>;
+template class ArrayFitter<r_8>;
+#endif
+
